VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Statement"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Index while contained in a Collection
Private myIndex As Integer
' Type of Statement (see Routine which returns text)
Private myStatement As Byte
' Each Statement Type has certain attributes stored here
Private myB(6) As Byte
' Can have some text associated with it
Private myText As String

Public Property Get Index() As Integer
    Index = myIndex
End Property

Public Property Let Index(NewIndex As Integer)
    myIndex = NewIndex
End Property

Public Property Get Statement() As Byte
    Statement = myStatement
End Property

Public Property Let Statement(NewStatement As Byte)
    Dim c As Integer
    myStatement = NewStatement
    ' Wipe out myB()
    For c = 0 To 6
        myB(c) = 0
    Next c
    ' Wipe out myText
    myText = ""
End Property

Public Property Get B(Index As Integer) As Integer
    B = CInt(myB(Index))
End Property

Public Property Let B(Index As Integer, NewB As Integer)
    myB(Index) = CByte(NewB)
End Property

Public Property Get Text() As String
    Text = Trim(myText)
End Property

Public Property Let Text(NewText As String)
    myText = Trim(NewText)
End Property

Public Sub Copy(FromStatement As Statement)
    Dim c As Integer
    ' Copy Type and Vars
    myStatement = FromStatement.Statement
    For c = 0 To 6
         myB(c) = FromStatement.B(c)
    Next c
    ' Copy Text
    myText = FromStatement.Text
End Sub

Public Sub ReadFromFile(FromFile As Integer)
    Dim c As Integer, Cnt As Long
    ' Read Index and Vars
    Get FromFile, , myIndex
    Get FromFile, , myStatement
    For c = 0 To 6
        Get FromFile, , myB(c)
    
    Next c
    ' Read Text
    Get FromFile, , Cnt
    myText = ""
    For c = 1 To Cnt
        myText = myText & " "
    Next c
    Get FromFile, , myText
End Sub

Public Sub SaveToFile(ToFile As Integer)
    Dim c As Integer
    ' Save Index and Vars
    Put ToFile, , myIndex
    Put ToFile, , myStatement
    For c = 0 To 6
        Put ToFile, , myB(c)
    Next c
    ' Save Text
    Put ToFile, , Len(myText)
    Put ToFile, , myText
End Sub

Private Sub Class_Initialize()
    myStatement = 54    ' TriggerComment
    myText = ""
End Sub
