VERSION 5.00
Begin VB.Form frmParty 
   BorderStyle     =   3  'Fixed Dialog
   ClientHeight    =   5805
   ClientLeft      =   2265
   ClientTop       =   2025
   ClientWidth     =   8715
   ControlBox      =   0   'False
   Icon            =   "dv_ad1c.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   MouseIcon       =   "dv_ad1c.frx":0442
   MousePointer    =   99  'Custom
   PaletteMode     =   1  'UseZOrder
   Picture         =   "dv_ad1c.frx":0594
   ScaleHeight     =   387
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   581
   ShowInTaskbar   =   0   'False
End
Attribute VB_Name = "frmParty"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Const CONTENTS_LIST = 0
Const OBJECTS_LIST = 1
Const READY_LIST = 2
Const ALL_LISTS = 3
Dim CurrChar As Integer
Dim DragFromList As Integer
Dim ItemToCombine As Integer
Dim FindMatch As Integer
Dim ItemOpen(4) As Integer
Dim EquippedOpen(4) As Integer
Dim SuppliesOpen(4) As Integer
Dim FromList As Integer
Dim ToList As Integer
Dim Mode As Integer
Dim LastChoice As Integer

Private Sub CloseItem()
    ' Close Contents list
    picContents.Visible = False
    lstContents.Visible = False
    ItemOpen(CurrChar) = -1
    ShowItems CurrChar, ALL_LISTS
    'ShowItems
End Sub

Public Sub CombineSelectedItems()
    Dim c As Integer, i As Integer
    Dim LastItem As Integer
    LastItem = -1
    ' Combine from lstObjects first
    If lstObjects.Visible = True Then
        c = 0
        Do While c < lstObjects.ListCount
            If lstObjects.Selected(c) Then
                ' If have a previous selected item
                If LastItem > -1 Then
                    ' If can combine together
                    If CombineItems(CurrChar, lstObjects.ItemData(c), LastItem) Then
                        lstObjects.RemoveItem c
                        c = c - 1
                    Else
                        LastItem = lstObjects.ItemData(c)
                    End If
                Else
                    LastItem = lstObjects.ItemData(c)
                End If
            End If
            c = c + 1
        Loop
    End If
    ' Trade from lstWear
    If lstWear.Visible = True Then
        c = 0
        Do While c < lstWear.ListCount
            If lstWear.Selected(c) Then
                If LastItem > -1 Then
                    ' Unready item (if necessary)
                    If UnReadyItem(CurrChar, lstWear.ItemData(c)) Then
                        ' If can combine together
                        If CombineItems(CurrChar, lstWear.ItemData(c), LastItem) Then
                            lstWear.RemoveItem c
                            c = c - 1
                        Else
                            LastItem = lstWear.ItemData(c)
                        End If
                    Else
                        LastItem = lstWear.ItemData(c)
                    End If
                Else
                    LastItem = lstWear.ItemData(c)
                End If
            End If
            c = c + 1
        Loop
    End If
    ' Trade from lstContents
    If lstContents.Visible = True Then
        c = 0
        Do While c < lstContents.ListCount
            If lstContents.Selected(c) Then
                ' If have a previous selected item
                If LastItem > -1 Then
                    ' If can combine together
                    If CombineItems(CurrChar, lstContents.ItemData(c), LastItem) Then
                        lstContents.RemoveItem c
                        c = c - 1
                    Else
                        LastItem = lstContents.ItemData(c)
                    End If
                Else
                    LastItem = lstContents.ItemData(c)
                End If
            End If
            c = c + 1
        Loop
    End If
    ShowItems CurrChar, ALL_LISTS
End Sub
Public Sub DrawFace(CharToDraw As Integer)
    ' Draw just the face of the character
    Dim Suc As Integer, Size As Double
    Dim FaceHeight As Integer, FaceWidth As Integer
    Dim FaceX As Integer, FaceY As Integer
    ' Set original coordinates for face (before stretch)
    FaceHeight = PC(CharToDraw).Face.Height
    FaceWidth = PC(CharToDraw).Face.Width
    FaceX = PC(CharToDraw).Face.Left
    FaceY = PC(CharToDraw).Face.Top
    ' Set stretch mode to color
    Suc = SetStretchBltMode(picChar(CharToDraw).hdc, 3)
    ' Copy mask and picture
    Suc = StretchBlt(picChar(CharToDraw).hdc, 0, 0, picChar(CharToDraw).Width, picChar(CharToDraw).Height, picMask(CharToDraw).hdc, FaceX + picMask(CharToDraw).ScaleWidth / 2, FaceY, FaceWidth, FaceHeight, &H8800C6) 'H8800C6
    Suc = StretchBlt(picChar(CharToDraw).hdc, 0, 0, picChar(CharToDraw).Width, picChar(CharToDraw).Height, picMask(CharToDraw).hdc, FaceX, FaceY, FaceWidth, FaceHeight, &HEE0086) '&HEE0086
    ' Refresh so can see the picture
    picChar(CharToDraw).Refresh
End Sub

Private Function CombineItems(FromChar As Integer, FromItem As Integer, ToItem As Integer) As Integer
    ' Has to match id and name
    ' add special combine number thing which produces new item
    ' NOTE: Little bug here: an already combined item can be traded into ready slot
    ' and avoid the quantity check (it does not check quantity prior to ready)
    ' But you cannot combine ANOTHER set into ready (it does check quantity after an item IS ready)
    Dim c As Integer
    ' If Item IDs match and Names match then attempt combine
    If PartyItem(FromItem).i(0) = PartyItem(ToItem).i(0) And PartyItem(ToItem).Name = PartyItem(FromItem).Name Then
        c = PartyItem(FromItem).i(6)
        If DropItem(FromChar, FromItem, True) Then
            PartyItem(ToItem).i(6) = PartyItem(ToItem).i(6) + PartyItem(FromItem).i(6) + 1
            CombineItems = True
        Else
            CombineItems = False
        End If
    Else
        CombineItems = False
    End If
End Function
Public Sub DropContents(CharFrom As Integer, ItemToDrop As Integer)
    Dim ii As Integer
    ' Recurse through items and drop each one
    For ii = 0 To 255
        If PartyItem(ii).i(1) = ItemToDrop + 255 Then
            DropContents CharFrom, ii
        ElseIf ii = ItemToDrop Then
            ' If in DV, drop (destroy). Else, drop to Item()
            DropItem CharFrom, ii, MapMode = 0
        End If
    Next ii
    ' Redisplay list of items
    ShowItems CharFrom, FromList
End Sub
Public Function DropItem(CharFrom As Integer, ItemToDrop As Integer, Destroy As Integer) As Integer
    Dim n As Integer
    ' See if can UnReady the item attempting to drop
    If Not UnReadyItem(CharFrom, ItemToDrop) Then
        DropItem = False
    Else
        If Destroy Then
            PartyItem(ItemToDrop).i(1) = 0
            DropItem = True
        Else
            ' Add item to encounter set of items
            PartyItem(ItemToDrop).i(1) = 0
            DropItem = True
        End If
    End If
    If DropItem Then
        RemoveItem CharFrom, ItemToDrop
    End If
End Function

Public Sub LoadCharPics()
    ' Load the character pictures and display
    ' Assumes Party and PC() already loaded
    Dim c As Integer
    Screen.MousePointer = 11
    For c = 0 To 4
        If Party.Member(c) > 0 Then
            picMask(c).Picture = LoadPicture(App.Path & "/lib/bmp/char" & Trim$(Format$(PC(c).i(44), "000")) & ".bmp")
            DrawFace c
            picChar(c).Enabled = True
        Else
            picChar(c).Enabled = False
        End If
    Next c
    Screen.MousePointer = 0
    ' Set CurrChar to 0
    If Party.Member(0) > 0 Then
        SelectChar 0
    End If
End Sub

Private Sub InitGame()
    Dim c As Integer
    ' Clear lists open flag
    For c = 0 To 4
        ItemOpen(c) = -1
        EquippedOpen(c) = 0
        SuppliesOpen(c) = 0
    Next c
End Sub

Private Sub ShowMessage(Text As String)
    ' Shows text in the message bar
    frmMain.ShowMessage Text
End Sub
Private Sub AddItemToList(lstBox As ListBox, WhichItem As Integer)
    ' Add item name to list (but do not show current open item in any list)
    If WhichItem <> ItemOpen(CurrChar) Then
        If PartyItem(WhichItem).i(6) > 0 Then
            lstBox.AddItem Trim(Str(PartyItem(WhichItem).i(6) + 1)) & " " & Trim(PartyItem(WhichItem).Name) & "s"
        Else
            lstBox.AddItem Trim(PartyItem(WhichItem).Name)
        End If
        lstBox.ItemData(lstBox.NewIndex) = WhichItem
    End If
End Sub

Private Sub OpenLists(ListToOpen As Integer)
    Select Case ListToOpen
        Case 0  ' Equipped
            FlickText lblObjects(ListToOpen)
            If EquippedOpen(CurrChar) = 0 Then
                picEquipped.Top = 186
                lstWear.Visible = True
                EquippedOpen(CurrChar) = 1
            Else
                picEquipped.Top = 297
                lstWear.Visible = False
                EquippedOpen(CurrChar) = 0
            End If
        Case 1  ' Supplies
            FlickText lblObjects(ListToOpen)
            If SuppliesOpen(CurrChar) = 0 Then
                picSupplies.Top = 186
                lstObjects.Visible = True
                SuppliesOpen(CurrChar) = 1
            Else
                picSupplies.Top = 297
                lstObjects.Visible = False
                SuppliesOpen(CurrChar) = 0
            End If
        Case 2  ' Contents
            If ItemOpen(CurrChar) > -1 Then
                FlickText lblObjects(ListToOpen)
                CloseItem
            End If
    End Select
End Sub

Private Sub ShowItems(CharToShow As Integer, ListToShow As Integer)
    Dim c As Integer, n As Integer
    ' Clear lists
    If ListToShow = CONTENTS_LIST Or ListToShow = ALL_LISTS Then
        lstContents.Clear
    End If
    If ListToShow = OBJECTS_LIST Or ListToShow = ALL_LISTS Then
        lstObjects.Clear
    End If
    If ListToShow = READY_LIST Or ListToShow = ALL_LISTS Then
        lstWear.Clear
    End If
    ' Show lists
    For c = 0 To 255
        If PartyItem(c).i(1) - 255 = ItemOpen(CharToShow) And (ListToShow = CONTENTS_LIST Or ListToShow = ALL_LISTS) Then
            AddItemToList lstContents, c
        Else
            n = PartyItem(c).i(1) - 1
            If n = CharToShow Then
                ' If item is being worn, show it in the wearing list. Else in normal list
                If (PartyItem(c).i(18) And Bit(13)) = Bit(13) Then
                    If ListToShow = READY_LIST Or ListToShow = ALL_LISTS Then
                        AddItemToList lstWear, c
                    End If
                ElseIf ListToShow = OBJECTS_LIST Or ListToShow = ALL_LISTS Then
                    AddItemToList lstObjects, c
                End If
            End If
        End If
    Next c
End Sub
Public Sub SplitSelectedItems()
    Dim c As Integer, i As Integer
    ' Split from lstObjects first
    If lstObjects.Visible = True Then
        c = 0
        Do While c < lstObjects.ListCount
            If lstObjects.Selected(c) Then
                i = SplitItem(CurrChar, lstObjects.ItemData(c))
            End If
            c = c + 1
        Loop
    End If
    ' Split from lstWear
    If lstWear.Visible = True Then
        c = 0
        Do While c < lstWear.ListCount
            If lstWear.Selected(c) Then
                i = SplitItem(CurrChar, lstWear.ItemData(c))
            End If
            c = c + 1
        Loop
    End If
    ' Split from lstContents
    If lstContents.Visible = True Then
        c = 0
        Do While c < lstContents.ListCount
            If lstContents.Selected(c) Then
                i = SplitItem(CurrChar, lstContents.ItemData(c))
            End If
            c = c + 1
        Loop
    End If
    ' Redisplay lists
    ShowItems CurrChar, ALL_LISTS
End Sub

Private Function SplitItem(ToChar As Integer, ItemToSplit As Integer) As Integer
    Dim c As Integer, n As Integer, NewItem As ItemType
    ' Create new item as half of item
    ' NOTE: Need to write code to handle copy of events
    NewItem = PartyItem(ItemToSplit)
    NewItem.i(6) = Int((PartyItem(ItemToSplit).i(6) - 1) / 2)
    If AddItemToChar(ToChar, 1, NewItem) Then
        PartyItem(ItemToSplit).i(6) = Int(PartyItem(ItemToSplit).i(6) / 2)
        SplitItem = True
    Else
        SplitItem = False
    End If
End Function


Public Sub SelectChar(CharToPlay As Integer)
    Dim Found As Integer, c As Integer
    ' Show name
    lblStat(12).Caption = Trim$(PC(CharToPlay).Name)
    ' Show HP
    lblStat(0).Caption = "HP " & Trim$(Str$(PC(CharToPlay).i(3)) & "/" & Trim$(Str$(PC(CharToPlay).i(4))))
    If PC(CharToPlay).i(3) < 1 Then
        shpStat(0).Width = 0
    Else
        shpStat(0).Width = 86 * (PC(CharToPlay).i(3) / PC(CharToPlay).i(4))
        If shpStat(0).Width > 86 Then
            shpStat(0).Width = 86
        End If
    End If
    ' Show END
    lblStat(1).Caption = "END " & Trim$(Str$(PC(CharToPlay).i(18)))
    If PC(CharToPlay).i(18) < 1 Then
        shpStat(1).Width = 0
    Else
        shpStat(1).Width = 86 * (PC(CharToPlay).i(18) / (PC(CharToPlay).i(9) + PC(CharToPlay).i(15)))
        If shpStat(1).Width > 86 Then
            shpStat(1).Width = 86
        End If
    End If
    ' Show AR
    lblStat(2).Caption = "AR " & Trim$(Str$(PC(CharToPlay).i(36)))
    If PC(CharToPlay).i(36) < 1 Then
        shpStat(2).Width = 0
    Else
        shpStat(2).Width = 86 * (PC(CharToPlay).i(36) / 25)
        If shpStat(2).Width > 86 Then
            shpStat(2).Width = 86
        End If
    End If
    ' Show Power, Speed, Mental
    lblStat(3).Caption = "Muscle " & Trim$(Str$(PC(CharToPlay).i(9)))
    If PC(CharToPlay).i(9) < 1 Then
        shpStat(3).Width = 0
    Else
        shpStat(3).Width = 86 * (PC(CharToPlay).i(9) / 25)
        If shpStat(3).Width > 86 Then
            shpStat(3).Width = 86
        End If
    End If
    lblStat(4).Caption = "Speed " & Trim$(Str$(PC(CharToPlay).i(12)))
    If PC(CharToPlay).i(12) < 1 Then
        shpStat(4).Width = 0
    Else
        shpStat(4).Width = 86 * (PC(CharToPlay).i(12) / 25)
        If shpStat(4).Width > 86 Then
            shpStat(4).Width = 86
        End If
    End If
    lblStat(5).Caption = "Will " & Trim$(Str$(PC(CharToPlay).i(15)))
    If PC(CharToPlay).i(15) < 1 Then
        shpStat(5).Width = 0
    Else
        shpStat(5).Width = 86 * (PC(CharToPlay).i(15) / 25)
        If shpStat(5).Width > 86 Then
            shpStat(5).Width = 86
        End If
    End If
    ' Show Fame and Skill Points Now
    lblStat(6).Caption = "Fame " & Trim$(Str$(PC(CharToPlay).i(41)))
    lblStat(7).Caption = "Skill " & Trim$(Str$(PC(CharToPlay).i(42)))

    lblStat(9).Caption = Status(PC(CharToPlay).i(39))

    ' Set player now
    CurrChar = CharToPlay
    ' Show all the items for the character
    If ItemOpen(CurrChar) > -1 Then
        OpenItem ItemOpen(CurrChar)
    Else
        CloseItem
    End If
    ' Show lists which are open
    If SuppliesOpen(CurrChar) = 1 Then
        picSupplies.Top = 186
        lstObjects.Visible = True
    Else
        picSupplies.Top = 297
        lstObjects.Visible = False
    End If
    If EquippedOpen(CurrChar) = 1 Then
        picEquipped.Top = 186
        lstWear.Visible = True
    Else
        picEquipped.Top = 297
        lstWear.Visible = False
    End If
End Sub
Private Sub Form_Load()
    InitGame
End Sub

Private Sub lblObjects_Click(Index As Integer)
    OpenLists Index
End Sub

Private Sub lblObjects_MouseMove(Index As Integer, Button As Integer, Shift As Integer, x As Single, y As Single)
    If LastChoice <> Index Then
        If LastChoice > -1 Then
            lblObjects(LastChoice).ForeColor = &HC0C0C0
            lblObjects(LastChoice).Refresh
        End If
        LastChoice = Index
        lblObjects(Index).ForeColor = RGB(255, 255, 0)
        lblObjects(Index).Refresh
    End If
End Sub

Private Sub lblStat_Click(Index As Integer)
    SavePicture frmParty.Image, "c:\test.bmp"
End Sub

Private Sub lstContents_DragDrop(Source As Control, x As Single, y As Single)
    If DragFromList <> CONTENTS_LIST Then
        TradeSelectedItems CurrChar, CurrChar, CONTENTS_LIST
    End If
End Sub

Private Sub lstContents_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    DragFromList = CONTENTS_LIST
    lstContents.Drag 1
End Sub

Private Sub lstContents_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    DragFromList = -1
    lstContents.Drag 0
End Sub



Private Sub picChar_Click(Index As Integer)
    SelectChar Index
End Sub



Private Sub picChar_DragDrop(Index As Integer, Source As Control, x As Single, y As Single)
    TradeSelectedItems CurrChar, Index, OBJECTS_LIST
End Sub


