VERSION 5.00
Begin VB.Form frmSearch 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Search"
   ClientHeight    =   2610
   ClientLeft      =   45
   ClientTop       =   360
   ClientWidth     =   5580
   Icon            =   "Am_Search.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   2610
   ScaleWidth      =   5580
   Begin VB.ComboBox cmbSearchDirection 
      Height          =   315
      Left            =   2940
      Style           =   2  'Dropdown List
      TabIndex        =   16
      Top             =   1020
      Width           =   1155
   End
   Begin VB.CommandButton btnReplaceAll 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Cancel          =   -1  'True
      Caption         =   "Replace All"
      Enabled         =   0   'False
      Height          =   315
      Left            =   4320
      TabIndex        =   15
      Top             =   1620
      Width           =   1095
   End
   Begin VB.ComboBox cmbReplaceWith 
      Enabled         =   0   'False
      Height          =   315
      Left            =   1200
      Style           =   2  'Dropdown List
      TabIndex        =   14
      Top             =   540
      Width           =   2895
   End
   Begin VB.CommandButton btnReplace 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Replace"
      Enabled         =   0   'False
      Height          =   315
      Left            =   4320
      TabIndex        =   12
      Top             =   1200
      Width           =   1095
   End
   Begin VB.CheckBox chkSearch 
      Caption         =   "Use Pattern Matching"
      Height          =   255
      Index           =   2
      Left            =   2100
      TabIndex        =   11
      Top             =   2100
      Width           =   2055
   End
   Begin VB.CheckBox chkSearch 
      Caption         =   "Match Case"
      Height          =   255
      Index           =   1
      Left            =   2100
      TabIndex        =   10
      Top             =   1800
      Width           =   2055
   End
   Begin VB.CheckBox chkSearch 
      Caption         =   "Find Whole Word Only"
      Height          =   255
      Index           =   0
      Left            =   2100
      TabIndex        =   9
      Top             =   1500
      Width           =   2055
   End
   Begin VB.Frame Frame1 
      Caption         =   "Search"
      Height          =   1575
      Left            =   120
      TabIndex        =   4
      Top             =   900
      Width           =   1815
      Begin VB.OptionButton optSearch 
         Caption         =   "Triggers"
         Height          =   255
         Index           =   3
         Left            =   240
         TabIndex        =   8
         Top             =   1200
         Width           =   1095
      End
      Begin VB.OptionButton optSearch 
         Caption         =   "Items"
         Height          =   255
         Index           =   2
         Left            =   240
         TabIndex        =   7
         Top             =   900
         Width           =   1215
      End
      Begin VB.OptionButton optSearch 
         Caption         =   "Creatures"
         Height          =   255
         Index           =   1
         Left            =   240
         TabIndex        =   6
         Top             =   600
         Width           =   1215
      End
      Begin VB.OptionButton optSearch 
         Caption         =   "Encounters"
         Height          =   255
         Index           =   0
         Left            =   240
         TabIndex        =   5
         Top             =   300
         Width           =   1275
      End
   End
   Begin VB.CommandButton btnCancel 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Cancel"
      Height          =   315
      Left            =   4320
      TabIndex        =   3
      Top             =   600
      Width           =   1095
   End
   Begin VB.CommandButton btnFindNext 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Find Next"
      Height          =   315
      Left            =   4320
      TabIndex        =   2
      Top             =   180
      Width           =   1095
   End
   Begin VB.TextBox txtFindWhat 
      Height          =   285
      Left            =   1200
      TabIndex        =   0
      Top             =   180
      Width           =   2895
   End
   Begin VB.Label Label3 
      Caption         =   "Direction"
      Height          =   255
      Left            =   2100
      TabIndex        =   17
      Top             =   1080
      Width           =   795
   End
   Begin VB.Label Label2 
      Caption         =   "Replace With"
      Height          =   255
      Left            =   120
      TabIndex        =   13
      Top             =   600
      Width           =   1095
   End
   Begin VB.Label Label1 
      Caption         =   "Find What"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   240
      Width           =   975
   End
End
Attribute VB_Name = "frmSearch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim ObjectType As Integer

Private Sub InitGame()
    optSearch(0).Value = True
    chkSearch(2).Value = 1
    ' Add Direction Options
    cmbSearchDirection.AddItem "All"
    cmbSearchDirection.AddItem "Down"
    cmbSearchDirection.AddItem "Up"
    cmbSearchDirection.ListIndex = 0
End Sub

Public Sub ReplaceList()
    Dim c As Integer
    cmbReplaceWith.Clear
    For c = 1 To frmMDI.CopyBufferSet.Count
        If frmMDI.ParseTag(frmMDI.CopyBufferTags(c)) = ObjectType Then
            cmbReplaceWith.AddItem frmMDI.CopyBufferSet(c).Name
            cmbReplaceWith.ItemData(cmbReplaceWith.NewIndex) = c
        End If
    Next c
    cmbReplaceWith.Enabled = (cmbReplaceWith.ListCount > 0)
    btnReplace.Enabled = (cmbReplaceWith.ListCount > 0)
    btnReplaceAll.Enabled = (cmbReplaceWith.ListCount > 0)
    If cmbReplaceWith.Enabled = True Then
        cmbReplaceWith.ListIndex = 0
    End If
End Sub

Public Function FindNext(Silent As Integer) As Integer
    FindNext = frmMDI.FindNext(txtFindWhat.Text, ObjectType, cmbSearchDirection.ListIndex, (chkSearch(0).Value = 1), (chkSearch(1).Value = 1), (chkSearch(2).Value = 1), Silent)
End Function

Private Sub btnCancel_Click()
    Unload Me
End Sub

Private Sub btnFindNext_Click()
    FindNext False
End Sub

Private Sub btnReplace_Click()
    If cmbReplaceWith.ListIndex > -1 Then
        frmMDI.FindReplace cmbReplaceWith.ItemData(cmbReplaceWith.ListIndex), True
        FindNext False
    End If
End Sub

Private Sub btnReplaceAll_Click()
    Dim Found As Integer
    If cmbReplaceWith.ListIndex > -1 Then
        frmMDI.FindReplace cmbReplaceWith.ItemData(cmbReplaceWith.ListIndex), False
        Do Until FindNext(True) = False
            frmMDI.FindReplace cmbReplaceWith.ItemData(cmbReplaceWith.ListIndex), False
        Loop
        frmMDI.OpenArea frmMDI.Area
    End If
End Sub

Private Sub Form_Load()
    InitGame
End Sub

Private Sub optSearch_Click(Index As Integer)
    Dim c As Integer
    For c = 0 To 3
        If optSearch(c).Value = True Then
            Select Case c
                Case 0  ' Encounters
                    ObjectType = bdEditEncounter
                Case 1  ' Creatures
                    ObjectType = bdEditCreature
                Case 2  ' Items
                    ObjectType = bdEditItem
                Case 3  ' Triggers
                    ObjectType = bdEditTrigger
            End Select
            Exit For
        End If
    Next c
    ReplaceList
End Sub

Private Sub txtFindWhat_Change()
    frmMDI.LastNode = 0
End Sub
