VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form frmTileSetProp 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Combat Wallpaper Properties"
   ClientHeight    =   4005
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   5880
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MDIChild        =   -1  'True
   MinButton       =   0   'False
   ScaleHeight     =   4005
   ScaleWidth      =   5880
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   180
      Top             =   3600
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Frame fraTileSetProp 
      Caption         =   "Attributes"
      Height          =   2895
      Left            =   180
      TabIndex        =   4
      Top             =   420
      Width           =   5535
      Begin VB.PictureBox picCombatWallpaper 
         AutoRedraw      =   -1  'True
         BackColor       =   &H8000000C&
         Height          =   1875
         Left            =   1500
         ScaleHeight     =   121
         ScaleMode       =   3  'Pixel
         ScaleWidth      =   161
         TabIndex        =   10
         Top             =   900
         Width           =   2475
      End
      Begin VB.CommandButton btnBrowse 
         Appearance      =   0  'Flat
         BackColor       =   &H80000005&
         Caption         =   "Browse..."
         Height          =   315
         Left            =   4320
         TabIndex        =   7
         Top             =   465
         Width           =   1095
      End
      Begin VB.TextBox txtCombatPic 
         Height          =   285
         Left            =   2520
         TabIndex        =   6
         Text            =   "Text1"
         Top             =   480
         Width           =   1695
      End
      Begin VB.TextBox txtName 
         Height          =   285
         Left            =   180
         TabIndex        =   5
         Text            =   "123456789012345678901234567890"
         Top             =   480
         Width           =   2235
      End
      Begin VB.Label Label1 
         Caption         =   "Name"
         Height          =   195
         Index           =   0
         Left            =   180
         TabIndex        =   9
         Top             =   240
         Width           =   555
      End
      Begin VB.Label Label1 
         Caption         =   "Combat Wallpaper"
         Height          =   195
         Index           =   8
         Left            =   2520
         TabIndex        =   8
         Top             =   240
         Width           =   1515
      End
   End
   Begin VB.CommandButton btnCancel 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Cancel"
      Height          =   315
      Left            =   3540
      TabIndex        =   3
      Top             =   3600
      Width           =   1095
   End
   Begin VB.CommandButton btnOk 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "OK"
      Height          =   315
      Left            =   2340
      TabIndex        =   2
      Top             =   3600
      Width           =   1095
   End
   Begin VB.CommandButton btnApply 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Apply"
      Enabled         =   0   'False
      Height          =   315
      Left            =   4740
      TabIndex        =   1
      Top             =   3600
      Width           =   1095
   End
   Begin ComctlLib.TabStrip tabTileSetProp 
      Height          =   3435
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   5775
      _ExtentX        =   10186
      _ExtentY        =   6059
      _Version        =   327682
      BeginProperty Tabs {0713E432-850A-101B-AFC0-4210102A8DA7} 
         NumTabs         =   1
         BeginProperty Tab1 {0713F341-850A-101B-AFC0-4210102A8DA7} 
            Caption         =   "General"
            Key             =   ""
            Object.Tag             =   "1"
            ImageVarType    =   2
         EndProperty
      EndProperty
   End
End
Attribute VB_Name = "frmTileSetProp"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim TreeViewX As TreeView
Dim TileSetX As TileSet
Dim Dirty As Integer

Private Sub ShowCombatPic(PictureFile As String)
    Dim bmPic As BITMAPINFO, hMemPic As Long, FileName As String
    Dim lpMem As Long, rc As Long, TransparentRGB As Long
    Screen.MousePointer = 11    ' Hourglass
    FileName = Dir(frmMDI.Tome.LoadPath & "\" & PictureFile)
    If FileName = "" Then
        FileName = App.Path & "\data\graphics\wallpapers\" & PictureFile
    Else
        FileName = frmMDI.Tome.LoadPath & "\" & PictureFile
    End If
    frmMDI.ShowMsg "Loading Picture " & PictureFile & "..."
    ' Load TileSet bitmap
    ReadBitmapFile PictureFile, bmPic, hMemPic, TransparentRGB
    ' Paint bitmap to picture box using converted palette
    lpMem = GlobalLock(hMemPic)
    rc = SetStretchBltMode(picCombatWallpaper.hdc, 3)
    rc = StretchDIBits(picCombatWallpaper.hdc, _
        0, 0, picCombatWallpaper.ScaleWidth, picCombatWallpaper.ScaleWidth, _
        0, 0, bmPic.bmiHeader.biWidth, bmPic.bmiHeader.biHeight, _
        ByVal lpMem, bmPic, DIB_RGB_COLORS, SRCCOPY)
    picCombatWallpaper.Refresh
    ' Release memory
    rc = GlobalUnlock(hMemPic)
    rc = GlobalFree(hMemPic)
    Screen.MousePointer = 0     ' Default
End Sub

Private Sub SetCombatPic()
    On Error Resume Next
    dlgFile.FileName = App.Path & "\Data\Graphics\Wallpapers\*.bmp"
    dlgFile.CancelError = True
    dlgFile.Filter = "Bitmaps (*.bmp)|*.bmp|All Files (*.*)|*.*"
    dlgFile.FilterIndex = 1
    dlgFile.Flags = &H2000&
    dlgFile.ShowOpen
    If Err.Number = cdlCancel Then
        Exit Sub
    End If
    ' Depending on file chosen, get other files
    txtCombatPic.Text = dlgFile.FileTitle
    frmMDI.ShowMsg "Loading CombatWallpaper " & txtCombatPic.Text & "..."
    ShowCombatPic txtCombatPic.Text
End Sub

Public Sub ShowTileSet(InTree As TreeView, InTileSet As TileSet)
    Dim OldDirt As Integer
    OldDirt = frmMDI.Dirty
    Set TreeViewX = InTree
    Set TileSetX = InTileSet
    Me.Caption = "TileSet [" & TileSetX.Name & "]"
    txtName.Text = TileSetX.Name
    txtCombatPic.Text = TileSetX.PictureFile
    ShowCombatPic txtCombatPic.Text
    SetDirty False
    frmMDI.Dirty = OldDirt
End Sub

Private Sub SetDirty(Flag As Integer)
    btnApply.Enabled = Flag
    Dirty = Flag
    If Dirty = True Then
        frmMDI.Dirty = True
    End If
End Sub

Private Sub UpdateTileSet()
    TileSetX.Name = txtName.Text
    TileSetX.PictureFile = txtCombatPic.Text
    ' Update ProjectList
    TreeViewX.Nodes(Me.Tag).Text = TileSetX.Name
    SetDirty False
End Sub

Private Sub btnApply_Click()
    UpdateTileSet
End Sub

Private Sub btnBrowse_Click()
    SetCombatPic
End Sub

Private Sub btnCancel_Click()
    Unload Me
End Sub

Private Sub btnOk_Click()
    UpdateTileSet
    Unload Me
End Sub

Private Sub txtCombatPic_Change()
    SetDirty True
End Sub

Private Sub txtName_Change()
    SetDirty True
End Sub
